( 3iMenu.fs -- 2020-11-29---Sun---09:07 )
\ Develops menu capability for OLED screen on Piano PCB

\ AVR dependencies: 3iOLED.avr
\ Forth dependencies: 3iOLED.fs

\ Hardware: Yellow-Blue OLED display 128x64 pixels,  16-top pixels are YELLOW, remaining 48 pixels are BLUE
\ DESIGN: to read hardware buttons in real-time, need to debounce AND maintain state so only 1 press gets registered...

oled-page
2 oled-textsz s" PIANO!" .oled

1 oled-textsz 

\ Menu keys are 14,15,16,17
17 constant esc-key
16 constant left-key
15 constant right-key
14 constant ok-key

: menu-init
    esc-key   pullup \ ESC
    left-key  pullup \ LEFT
    right-key pullup \ RIGHT
    ok-key    pullup \ OK
;

: menu-read ( -- )
   esc-key pinread not if s" ESC!" .oled then
   left-key pinread not if s" LEFT!" .oled then
   right-key pinread not if s" RIGHT!" .oled then
   ok-key pinread not if s" OK!" .oled then
;

: menu-poll ( -- ) oled-page begin menu-read key? until ." Done!" ;

\ TO DO
\ 1/ LEFT/RIGHT changing the octave...
